module BranchUnit(
    input [31:0] srcA, srcB, //входы данных с регистров
    input [2:0] funct3, // вход funct3
    output reg branchTaken //выход сигнализирующий о наличии перехода
);
    always @(*) begin
        case (funct3)
            3'b000: branchTaken = (srcA == srcB); // BEQ
            3'b001: branchTaken = (srcA != srcB); // BNE
            3'b100: branchTaken = ($signed(srcA) < $signed(srcB)); // BLT
            3'b101: branchTaken = ($signed(srcA) >= $signed(srcB)); // BGE
            3'b110: branchTaken = (srcA < srcB); // BLTU
            3'b111: branchTaken = (srcA >= srcB); // BGEU
            default: branchTaken = 1'b0; // по умолчанию выход 0 
        endcase
    end
endmodule