`timescale 1ns / 1ps

module RISC_V_tb;

    // Параметры теста
    reg clk;
    reg reset;

    // Вызов процессора
    RISC_V uut (
        .clk(clk),
        .reset(reset)
    );

    // Инициализация сигналов
    initial begin
        clk = 0;
        reset = 1;
        #10; // Ждем 10 нс
        reset = 0; // Сбрасываем процессор

        // Здесь можно добавить тестовые данные в память и инициализацию

        // Пример 1: Выполнение нескольких циклов тактирования
        #10;
        clk = 1; // Поднять такт
        #10;
        clk = 0; // Опустить такт
        #10;

        // Добавляем ещё такты для проверки
        clk = 1; 
        #10;
        clk = 0; 
        #10;

        // Повторяем такты по мере необходимости
        clk = 1; 
        #10;
        clk = 0; 
        #10;

        // Закрыть симуляцию
        $finish;
    end

    // Генератор тактового сигнала
    always #5 clk = ~clk; // Обратное состояние каждые 5 нс

    // Процедура проверки результатов
    initial begin
        // Здесь можно добавить проверки выводов, например, вывод регистров или памяти
        // $monitor или $display могут быть использованы для наблюдения за переменными
        $monitor("At time %t: PC = %h", $time, uut.pc);
        // Можете добавить дополнительные проверки по мере необходимости
    end

endmodule