module DataMemory (
    input clk, //синхросигнал
    input [31:0] addr, // шина адреса
    input [31:0] writeData, //входная шина данных 
    input memWrite, // сигнал управления записи
    input memRead, //сигнал управления чтением
    output [31:0] readData //выход данных
);
    reg [7:0] mem [0:255];// объем памяти равен 256 байт

    // Чтение данных
    assign readData = memRead ? {mem[addr+3], mem[addr+2], mem[addr+1], mem[addr]} : 32'b0;
	// здесь данные как раз объединаются с применением конкатенации
    // Запись данных по фронту clk
    always @(posedge clk) begin
        if (memWrite) begin 
            //здесь данные из 32-х битного слова делятся на 4 байта 
				mem[addr]   <= writeData[7:0];
            mem[addr+1] <= writeData[15:8];
            mem[addr+2] <= writeData[23:16];
            mem[addr+3] <= writeData[31:24];
				//здесь данные из 32-х битного слова делятся на 4 байта 
        end
    end
endmodule