module InstructionDecoder(
    input [31:0] instr,
    output [6:0] opcode,
    output [4:0] rd,
    output [2:0] funct3,
    output [4:0] rs1, rs2,
    output [6:0] funct7,
    output [31:0] imm
);
    assign opcode = instr[6:0];// выделяем 0 по 6 бит под opcode
    assign rd = instr[11:7]; //с 7 по 11 бит адрес регистра назначения
    assign funct3 = instr[14:12]; //с 12 по 14 бит поле funct3
    assign rs1 = instr[19:15];//с 15 по 19 бит адрес регистра источника 1
    assign rs2 = instr[24:20];//с 20 по 24 бит адрес регистра источника 2
    assign funct7 = instr[31:25];
    assign imm = { {21{instr[31]}}, instr[30:20] }; //формируемое поле непосредственных значений Immediate (I-Type)
endmodule