module RegisterFile(
    input clk,              // синхросигнал
    input reset,            // сигнал сброса
    input regWrite,         // сигнал разрешения записи в регистр
    input [4:0] rs1, rs2, rd, // адреса регистров
    input [31:0] writeData,  // вход данных для записи
    output [31:0] readData1, readData2 // выходные шины данных
);
    reg [31:0] regs [0:31]; // регистровый файл

    // Чтение регистров (асинхронное)
    assign readData1 = regs[rs1];
    assign readData2 = regs[rs2];
		integer i;
    // Синхронный сброс и запись в регистр
    always @(posedge clk) begin
        if (reset) begin
            // Очистка всех регистров при активном сигнале сброса
            
            for (i = 0; i < 32; i = i + 1) begin
                regs[i] <= 32'd0;
            end
        end else if (regWrite && rd != 5'd0) begin
            // Запись в регистр (кроме регистра x0, который всегда равен 0)
            regs[rd] <= writeData;
        end
    end
endmodule